<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Gestionar Perfiles</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>¡Comencemos!</strong>
      </div>
      <div class="supSec">
        ¿Deseas gestionar, editar o crear un Perfil?
      </div>
    </div>
    <div class="pl-10 pr-10 contSecc">
      <v-sheet class="overflow-y-auto CardScroll">
        <v-row>
          <v-col
            v-for="(perfil, indexPerfil) in perfiles"
            :key="indexPerfil"
            :xs="12"
            :sm="12"
            :md="3"
            :lg="2"
          >
            <v-card class="generalCard pa-4">
              <div>
                <v-btn
                  x-small
                  class="float-left"
                  text
                  icon
                  @click="(dialogDelete = true), (perfil_delete = perfil)"
                >
                  <v-img
                    :contain="true"
                    :aspect-ratio="1"
                    :width="20"
                    position="center"
                    src="@/assets/img/delete.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
                <v-btn :to="perfil.to" x-small class="float-right" text icon>
                  <v-img
                    :contain="false"
                    :aspect-ratio="1"
                    :width="20"
                    position="center"
                    src="@/assets/img/icoEditar.svg"
                    class="white--text align-end"
                  ></v-img>
                </v-btn>
              </div>
              <v-card-text>
                <div class="cardFranqName cardFranqNameLine">
                  {{ perfil.descripcion }}
                </div>
                <div class="cardCreacion">
                  <div>
                    Fecha de creación:
                    {{ moment(perfil.fecha_creacion).format("DD/MM/YYYY") }}
                  </div>
                </div>
                <v-footer absolute class="CardCustomAction">
                  <v-col>
                    <v-btn
                      :to="perfil.to_flujos_perfil"
                      class="ma-2"
                      dark
                      tile
                      depressed
                      color="primary"
                      >Configurar Flujos</v-btn
                    >
                  </v-col>
                </v-footer>
              </v-card-text>
            </v-card>
          </v-col>
        </v-row>
      </v-sheet>
      <v-divider />
      <v-row>
        <v-col :key="cardAddPerfil.title" :xs="12" :sm="12" :md="6" :lg="3">
          <v-card
            :to="cardAddPerfil.to"
            :color="cardAddPerfil.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAddPerfil.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAddPerfil.src"
                :lazy-src="cardAddPerfil.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
      <template>
        <v-dialog v-model="dialogDelete" persistent max-width="600px">
          <v-card>
            <v-card-title>
              <div class="titModal">
                <strong>¿Seguro que deseas eliminar este perfil?</strong>
              </div>
            </v-card-title>
            <v-card-text></v-card-text>
            <v-card-actions>
              <v-row justify="center" style="margin-right:0px">
                <v-btn
                  class="ma-2"
                  dark
                  tile
                  depressed
                  color="secondary"
                  @click="dialogDelete = false"
                  >No, cancelar</v-btn
                >
                <v-btn
                  class="ma-2"
                  depressed
                  dark
                  tile
                  color="primary"
                  :class="[{ desac: deletingPerfil }]"
                  @click="deletePerfil()"
                  >Si, continuar</v-btn
                >
              </v-row>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </template>
    </div>
  </div>
</template>
<script>
import axios from "axios";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const user = serviceLocalStorage.userToken();
import moment from "moment";
export default {
  name: "Component-Perfiles",
  data() {
    return {
      moment: moment,
      perfil_delete: null,
      dialogDelete: false,
      deletingPerfil: false,
      cardAddPerfil: {
        title: "Crear Perfil",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade una nuevo perfil a la lista.",
        to: {
          name: "privilegios_perfiles_nuevo",
        },
        color: "#494949",
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Privilegios",
          disabled: false,
          exact: true,
          to: {
            name: "privilegios",
          },
        },
        {
          text: "Perfiles",
          disabled: true,
        },
      ],
      perfiles: [],
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
  },
  methods: {
    getPerfiles() {
      var self = this;
      axios
        .get("/perfil/secure/get/")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              self.setPerfiles(data);
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    },
    setPerfiles(data) {
      if (data) {
        data.forEach((itemPerfil) => {
          itemPerfil.to_flujos_perfil = {
            name: "privilegios_flujos_perfil",
            params: {
              perfil: this.serviceCommons.objectToBase64(itemPerfil),
            },
          };
          itemPerfil.escritura = 1;
          itemPerfil.to = {
            name: "privilegios_perfiles_edicion",
            params: {
              perfil: this.serviceCommons.objectToBase64(itemPerfil),
            },
          };
        });
        this.perfiles = data;
      }
    },
    deletePerfil() {
      var self = this;
      self.perfil_delete.id_empleado_modifica = user.empleado;
      axios
        .delete("/perfil/secure/delete", { data: self.perfil_delete })
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.dialogDelete = false;
              self.getPerfiles();
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.deletingPerfil = false;
        });
    },
  },
  created() {
    this.getPerfiles();
  },
};
</script>
